#include <stdio.h>
#include <stdlib.h>

#include <sys/time.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <assert.h>
#include <sys/mman.h>

#include "ticket.h"
#include "atomic.h"

int numThreads;
int tid_gen = 0;
pthread_mutex_t global_mutex = PTHREAD_MUTEX_INITIALIZER;


int __thread tid;

int ticket_pause (int delay) {

   int i, j;
   
   for (i = 0; i < delay; i ++) {
      //what do we want the base unit of waiting to be ? 1 nop ? 5 nops ?
      for (j = 0; j < TICKET_TIME_UNIT; j ++) {
         asm __volatile__ ("nop");
      }
   }
   
   return 0;
}


int ticket_mutex_init (ticket_mutex_t *mutex)
{
    mutex->next_ticket = 0;
    mutex->now_serving = 0;
    return 0;
}


int ticket_mutex_lock (ticket_mutex_t *mutex) 
{
    int my_ticket;
    
    //has to return old value
    my_ticket = fetch_and_increment (& (mutex->next_ticket));
    
    while (mutex->now_serving != my_ticket) {
       //implement backoff here; you can (should) use ticket_pause()
       ticket_pause (0);
    }

    return 0;
}

int ticket_mutex_unlock (ticket_mutex_t *mutex) 
{
   mutex->now_serving = mutex->now_serving + 1;
  
   return 0;
}
